package com.survey7.shareoverwifi;
/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.Socket;
import android.util.Log;
import android.content.Intent;
import android.net.Uri;
import android.content.Context;
import org.json.JSONObject;
import org.json.JSONArray;
import org.json.JSONException;


class Listener implements Runnable {
	private static final String DBG="DEBUG";
	private Context context;
	private byte[] packetdata=new byte[1500];
	private DatagramSocket DS=null;
	private DatagramPacket DP=null;
	private int port;
	private Quitsync qs;

	private void followvideo(String vidkey) {
		Intent intent;
		intent=new Intent(Intent.ACTION_VIEW, Uri.parse("vnd.youtube://"+vidkey));
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		context.startActivity(intent);
	}
	private void followurl(String url) {
		Intent intent;
		intent=new Intent(Intent.ACTION_VIEW, Uri.parse(url));
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		context.startActivity(intent);
	}
	private void parsejson(String js) {
		JSONObject json;
		String video=null,url=null;
		try {
			json=new JSONObject(js);
			video=json.optString("youtube",null);
			url=json.optString("url",null);
		} catch(org.json.JSONException e) {
		}
		if (video!=null) {
			Log.i(DBG,"Video found: "+video);
			followvideo(video);
		}
		if (url!=null) {
			Log.i(DBG,"Url found: "+url);
			followurl(url);
		}
	}
	private void listenonport() {
		int len,off;
		InetAddress addr;
		DP.setData(packetdata);
		try {
			DS.receive(DP);
		} catch (java.io.IOException e) {
			return;
		}
		addr=DP.getAddress();
		Log.i(DBG,"Received response from "+addr.toString());
		len=DP.getLength();
		off=DP.getOffset();
		Log.i(DBG,"Received \""+(new String(packetdata,off,len))+"\"");
		parsejson(new String(packetdata,off,len));
	}
	public void run() {
		try {
			DS=new DatagramSocket(port);
			DP=new DatagramPacket(packetdata,packetdata.length);
			DS.setSoTimeout(5*1000);
		} catch (java.net.SocketException e) {
			Log.e(DBG,"Error listening");
			return;
		}
		Log.i(DBG,"Waiting on port "+port);
		while (true) {
			boolean toquit;
			listenonport();
			synchronized(qs) {
				toquit=qs.toquit;
			}
			if (toquit) break;
		}
		Log.i(DBG,"Closing UDP socket and ending thread");
		DS.close();
	}
	Listener(Context ctx, int port_in, Quitsync qs_in) {
		context=ctx;
		port=port_in;
		qs=qs_in;
	}
}
