package com.survey7.shareoverwifi;
/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import android.app.Activity;
import android.content.res.Configuration;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.TextView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.LinearLayout;
import android.content.Intent;
import android.net.Uri;
import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.Socket;
import android.net.wifi.WifiManager;
import android.net.wifi.WifiInfo;
import android.app.ActivityManager;
import android.content.Context;
import android.view.Window;

public class Main extends Activity {
	private Globals globals;
	private byte[] subnet=new byte[4];
	private boolean servicerunning=false;

	private void checkforservice() {
		ActivityManager manager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
		for (ActivityManager.RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE)) {
				if (Servicemain.class.getName().equals(service.service.getClassName())) {
						servicerunning=true;
						return;
				}
		}
		servicerunning=false;
	}

	private void stopservice() {
		if (!servicerunning) return;
		stopService(new Intent(this,Servicemain.class));
		servicerunning=false;
		redraw();
	}

	private void startservice() {
		if (servicerunning) return;
		startService(new Intent(this,Servicemain.class));
		servicerunning=true;
		redraw();
	}
	private boolean sendrequest(String json) {
/*
		Log.e(globals.DBG,"Request: "+json);
		return true;
*/
		byte[] ip=new byte[4];
		int port=5698;
		boolean ret=true;
		byte[] packet;

		packet=json.getBytes();
		ip[0]=subnet[0];
		ip[1]=subnet[1];
		ip[2]=subnet[2];

		try {
			DatagramPacket DP;
			DatagramSocket DS;
			InetAddress addr;
			DS=new DatagramSocket();
			for (int i=1;i<255;i++) {
				ip[3]=(byte)i;
				addr=InetAddress.getByAddress(ip);
				DP=new DatagramPacket(packet,packet.length,addr,port);
				DS.send(DP);
			}
			ret=false;
		} catch(java.net.UnknownHostException e) {}
		catch(java.net.SocketException e) {}
		catch(java.io.IOException e) {}
		return ret;
/*
*/
	}
	private boolean sendurl(String text) {
		int i;
		i=text.indexOf("http://");
		if (i<0) {
			i=text.indexOf("https://");
			if (i<0) return true;
		}
		text=text.substring(i);
		return sendrequest("{\"url\":\""+text+"\"}");
	}

	private void findwifiaddress() {
		WifiManager WM=(WifiManager)getSystemService(WIFI_SERVICE);
		if (WM!=null) {
			WifiInfo WI=WM.getConnectionInfo();
			if (WI!=null) {
				int ip=WI.getIpAddress();
				subnet[0]=(byte)(ip&0xff);
				subnet[1]=(byte)((ip>>8)&0xff);
				subnet[2]=(byte)((ip>>16)&0xff);
				subnet[3]=0;
			}
		}
	}

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
	}
	@Override
	public void onCreate(Bundle savedInstanceState) {
		globals=(Globals)((globalcontainer)getApplicationContext()).globals;
		super.onCreate(savedInstanceState);

		findwifiaddress();
		globals.loadpreferences(this);

		String text=null;
		Intent intent = getIntent();

/*
		Log.e(globals.DBG,"Action: "+intent.getAction());
		Log.e(globals.DBG,"URI: "+intent.getDataString());
*/

		text=intent.getDataString();
		if (text==null) {
			Bundle extras=intent.getExtras();
			if (extras!=null) text=extras.getString(Intent.EXTRA_TEXT);
		}
		if (text!=null) {
			String[] first,second;
//			Log.e(globals.DBG,"Extras: "+text);
			first=text.split("\\?");
			if ((first.length==2)
					&& ((first[0].equals("https://www.youtube.com/watch"))
							||(first[0].equals("http://www.youtube.com/watch")))
					) {
// https://www.youtube.com/watch?v=hTzIfWK9mk8&feature=youtube_gdata_player
				second=first[1].split("&");
//				Log.e(globals.DBG,"second[0]="+second[0]);
				if (second[0].substring(0,2).equals("v=")) {
					String video;
					video=second[0].substring(2);
//					Log.e(globals.DBG,"Starting video \""+video+"\"");
					sendrequest("{\"youtube\":\""+video+"\"}");
				}
			} else {
//				Log.e(globals.DBG,"Sending url \""+text+"\"");
				sendurl(text);
			}
		}

		if (!isTaskRoot()) {
			finish();
			return;
		} // fixes Market double-start
	}
	@Override
	public void onResume() {
		super.onResume();

		setContentView(R.layout.main);

		checkforservice();
		redraw();
	}
	private void saveprefs() {
		globals.savepreference(this,"autostart",globals.autostart);
	}
	private void redraw() {
		TextView tv;
		Button tb;
		CheckBox cb;
		tv=(TextView)findViewById(R.id.bannertext);
		if (servicerunning)
			tv.setText("The server is running.");
		else
			tv.setText("This is currently running as a client. If you'd like to enable this device as a server, press the button below.");
		tb=(Button)findViewById(R.id.startbutton);
		tb.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) {
//					Log.e(globals.DBG,"Attempting to start service");
					startservice();
				}
		});
		if (!servicerunning) tb.setVisibility(View.VISIBLE);
		else tb.setVisibility(View.GONE);

		tb=(Button)findViewById(R.id.stopbutton);
		tb.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) {
//					Log.e(globals.DBG,"Attempting to stop service");
					stopservice();
				}
		});
		if (servicerunning) tb.setVisibility(View.VISIBLE);
		else tb.setVisibility(View.GONE);

		LinearLayout ll;
		ll=(LinearLayout)findViewById(R.id.startoptions);
		if ((servicerunning)||(globals.autostart)) {
			ll.setVisibility(View.VISIBLE);
			cb=(CheckBox)findViewById(R.id.startonboot);
			cb.setOnClickListener(new View.OnClickListener() {
					@Override
					public void onClick(View v) {
						CheckBox cbv=(CheckBox)v;
						globals.autostart=cbv.isChecked();
						saveprefs();
					}
			});
			cb.setChecked(globals.autostart);
		} else {
			ll.setVisibility(View.GONE);
		}
	}
}
