package com.survey7.shareoverwifi;
/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.net.Uri;
import java.lang.Thread;


public class Servicemain extends Service {
	private static final String DBG="DEBUG";
	private NotificationManager NM;
	private Thread listenthread=null;
	private Quitsync qs=new Quitsync();

	private void gangnamstyle() {
		Intent intent;
		intent=new Intent(Intent.ACTION_VIEW, Uri.parse("vnd.youtube://9bZkp7q19f0"));
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		startActivity(intent);
	}

	private void registernotification() {
		CharSequence text = getText(R.string.service_started);
		Notification notification = new Notification(R.drawable.icon, text,
						System.currentTimeMillis());
		notification.flags |= Notification.FLAG_NO_CLEAR;
		PendingIntent contentIntent = PendingIntent.getActivity(this, 0,
						new Intent(this, Main.class), 0);
		notification.setLatestEventInfo(this, getText(R.string.service_label),
									 text, contentIntent);
		NM.notify(R.string.service_started, notification);
	}

	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}
	
	@Override
	public void onCreate() {
		Log.i(DBG,"Service created");
		NM = (NotificationManager)getSystemService(NOTIFICATION_SERVICE);
		registernotification();
		listenthread=new Thread(new Listener(this,5698,qs));
		listenthread.start();
	}

	@Override
	public void onDestroy() {
		Log.i(DBG,"Service destroyed");
		synchronized(qs) {
			qs.toquit=true;
		}
		listenthread=null;
		NM.cancel(R.string.service_started);
	}
	
	@Override
	public void onStart(Intent intent, int startid) {
		Log.i(DBG,"Service started");
		if (listenthread==null) {
			listenthread=new Thread(new Listener(this,5698,qs));
			listenthread.start();
		}
	}
}
